<template>
  <div>
    <!-- <img
      :src="image"
      @click="handleClick()"
      :class="['delay-150 duration-200 -translate-x-1/2 -translate-y-1/2  left-1/2 top-1/2 transform transition-all',isClick ? classFixed : classRelative]"
      alt=""
    />
    <div v-if="isClick" class="fixed w-full h-screen bg-black z-60 bg-opacity-60" @click="handleClick()"></div> -->
    <zoombox :src="image" :thumb="image">
      <span>A caption</span>
      <span slot="loading">loading...</span>
      <span slot="opened">Will be shown besides the image when opened</span>
    </zoombox>
  </div>
</template>

<script>
import zoombox from "./zoombox";
var Overlay, Velocity, cancel;

  Velocity = require("velocity-animate");

  cancel = function(el) {
    return Velocity(el, "stop");
  };

  // Overlay = require("vue-overlay");

  // Overlay.obj.methods.fade = function(_arg) {
  //   var cb, el, opacity;
  //   el = _arg.el, opacity = _arg.opacity, cb = _arg.cb;
  //   return Velocity(el, {
  //     opacity: opacity
  //   }, {
  //     duration: 1000,
  //     queue: false,
  //     easing: 'easeOutQuad',
  //     complete: cb
  //   });
  // };
export default {
  props: {
    image: {
      type: String,
      default: "",
    },
  },
  data() {
    return {
      isClick: false,
      classRelative: "realtive w-full h-full object-cover object-center",
      classFixed: "fixed w-1/3 z-70",
    };
  },
  methods: {
    handleClick() {
      this.isClick = !this.isClick;
    },
  },
  components: {
    zoombox,
  },
  transitions: {
      zoombox: {
        css: false,
        leaveCancelled: cancel,
        enterCancelled: cancel,
        enter: function(el, done) {
          Velocity.hook(el, "scale", this.imgScale);
          return this.$nextTick((function(_this) {
            return function() {
              return Velocity(el, {
                scale: _this.imgScale * _this.scale,
                top: _this.relPos.top,
                left: _this.relPos.left
              }, {
                duration: 1000,
                queue: false,
                ease: "easeOutQuad",
                complete: done
              });
            };
          })(this));
        },
        leave: function(el, done) {
          Velocity.hook(el, "scale", this.imgScale * this.scale);
          return Velocity(el, {
            scale: this.imgScale,
            top: 0,
            left: 0
          }, {
            duration: 1000,
            queue: false,
            ease: "easeOutQuad",
            complete: done
          });
        }
      }
    }
};
</script>